﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4.5
@EndOfDesignText@
'Custom View class
'#Event: ExampleEvent (Value As Int)
#DesignerProperty: Key: digits, DisplayName: columns, FieldType: Int, DefaultValue: 7, MinRange: 0, MaxRange: 10, Description: Number of cells
#DesignerProperty: Key: theMessage, DisplayName: Message, FieldType: String, DefaultValue: Testing, Description: must not be lobger than digits.
#DesignerProperty: Key: cellHeight, DisplayName: Cell Height(half cell), FieldType: Float, DefaultValue: 40.0, Description: Height of half the cell.
#DesignerProperty: Key: cellWidth, DisplayName: Cell Width, FieldType: Float, DefaultValue: 50.0, Description: Width of the cell.

Sub Class_Globals
	Private fx As JFX
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Pane
	Private inline As JavaObject 
	Private grid As Node
	Private grid2 As Node
	Private img As Image
	Private letters As Map
	Dim iv(20) As ImageView
	Dim ivback(20) As ImageView
	Private cols As Int
	Private ivstrings(10) As String
	Private cellWidth,cellHeight As Double
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	inline = Me
	EventName = vEventName
	CallBack = vCallback
	grid = newGrid
	grid2 = newGrid
	img.Initialize(File.DirAssets,"flips.png")
	letters.Initialize
	buildLettersMap
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	CSSUtils.SetBorder(Base,0,fx.Colors.Transparent,0.0)
	cellWidth = Props.Get("cellWidth")
	cellHeight = Props.Get("cellHeight")
	Log(cellWidth & " " & cellHeight)
	cols = Props.Get("digits")
	For a = 0 To (cols*2)-1
		iv(a) = newImageView(cellWidth,cellHeight)
		setImage(iv(a),img,((a Mod cols)*75)+(a Mod 10),0.0,75.0,57.5)
		addToGrid(iv(a),1+(a Mod cols),1+(a/cols))
		ivback(a) = newImageView(cellWidth,cellHeight)
		setImage(ivback(a),img,((a Mod cols)*75)+(a Mod 10),0.0,75.0,57.5)
		addToGrid2(ivback(a),1+(a Mod cols),1+(a/cols))
	Next
	allBlank
	Base.AddNode(grid2,0,0,Base.PrefWidth,Base.PrefHeight)
	Base.AddNode(grid,0,0,Base.PrefWidth,Base.PrefHeight)
	Dim jj As JavaObject=grid2
	jj.RunMethod("toBack",Null)
	allBlank
	letterRuns(Props.Get("theMessage"))
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub
public Sub displayText(s As String)
	If s.Length > cols Then
		s = s.SubString2(0,cols) 
	End If
	allBlank
	letterRuns(s)
End Sub
private Sub allBlank
	For a = 0 To cols-1 
		Dim r,c As Int
		Dim item(2) As Object = letters.get(" ")
		c = item(0)
		r = item(1)
		setImage(iv(a),img,c*75.0+c,r*105.0,75.0,57.5)
		setImage(iv(a+cols),img,c*75.0+c,r*105.0+56.5,75.0,52.5)
		setImage(ivback(a),img,c*75.0+c,r*105.0,75.0,57.5)
		setImage(ivback(a+cols),img,c*75.0+c,r*105.0+56.5,75.0,52.5)
	Next
End Sub
private Sub letterRuns(s As String)
	s = s.ToUpperCase
	If s.Length > cols Then s = s.SubString2(0,cols)
	Do While s.Length <cols
		s = s & " "
	Loop
	Dim order As String = " 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ:"
	For aa = 0 To cols-1
		ivstrings(aa) = order.SubString2(0,1+order.IndexOf(s.SubString2(aa,aa+1))) 	
	Next
	Dim r,c,r1,c1 As Int
	Dim cnt As Int = 0
	Dim item(2) As Object
	Dim nextitem(2) As Object
	Dim aaa As Int
	Dim ls(cols),ls2(cols) As String
	Do While cnt<cols
		For aaa  = 0 To cols-1
			Dim animList As List
			animList.Initialize
			For dd = 0 To ivstrings(aaa).Length - 1
				ls(aaa) = ivstrings(aaa).CharAt(dd)
				If dd <= (ivstrings(aaa).Length - 2) Then 
					ls2(aaa) = ivstrings(aaa).CharAt(dd+1)
				Else
					ls2(aaa) = ls(aaa)	 
				End If
				item = letters.get(ls(aaa))
				c = item(0)
				r = item(1)
				nextitem = letters.get(ls2(aaa))
				c1 = nextitem(0)
				r1 = nextitem(1)
				setImage(iv(aaa),img,c*75.0+c,r*105.0,75.0,57.5)
				setImage(iv(aaa+cols),img,c*75.0+c,r*105.0+56.5,75.0,52.5)
				
				setImage(ivback(aaa),img,c1*75.0+c1,r1*105.0,75.0,57.5)
				setImage(ivback(aaa+cols),img,c1*75.0+c1,r1*105.0+56.5,75.0,52.5)
				Dim f1,f2,f3,f4,f5,f6,f7,f8 As Float
				f1=c*75.0+c
				f2=r*105.0
				f3=c*75.0+c
				f4=r*105.0+56.5
				f5=c1*75.0+c1
				f6=r1*105.0
				f7=c1*75.0+c1
				f8=r1*105.0+56.5
				'charList.Add(Array As String(ls(aaa),ls2(aaa)))
				If dd < ivstrings(aaa).Length - 1 Then animList.Add(Array As Float(f1,f2,f3,f4,f5,f6,f7,f8))
			Next
			setAnimation(aaa,Array As Object(iv(aaa),iv(aaa+cols),ivback(aaa),ivback(aaa+cols)),img,animList)
			animList.Clear
		Next 
		cnt=0
		For chk = 0 To cols-1
			If s.CharAt(chk)=ls(chk) Then
				cnt = cnt+1
			End If
		Next	
	Loop
End Sub
private Sub newGrid As Node
	Return inline.RunMethod("newGridPane",Null)
End Sub
private Sub addToGrid(g As Node,x As Int,y As Int)
	inline.RunMethod("addToGrid",Array(grid,g,x,y))
End Sub
private Sub addToGrid2(g As Node,x As Int,y As Int)
	inline.RunMethod("addToGrid",Array(grid2,g,x,y))
End Sub
private Sub newImageView(w As Double,h As Double) As Node
	Return inline.RunMethod("newImageView",Array(w,h))
End Sub
private Sub setImage(ivs As ImageView,im As Image,left As Double,top As Double,w As Double,h As Double)
	inline.RunMethod("setImage",Array(ivs,im,left,top,w,h))
End Sub
private Sub setAnimation(i As Int,iviews() As Object,im As Image,animlist As List)
	inline.RunMethod("buildAnimation",Array(grid,i,iviews,im,animlist))
End Sub
private Sub buildLettersMap
	For a = 1 To 9
	letters.put(a&"",Array((a-1),0))
	Next
	letters.put("0",Array(9,0))
	letters.Put("A",Array(0,2))
	letters.Put("B",Array(4,3))
	letters.Put("C",Array(2,3))
	letters.Put("D",Array(2,2))
	letters.Put("E",Array(2,1))
	letters.Put("F",Array(3,2))
	letters.Put("G",Array(4,2))
	letters.Put("H",Array(5,2))
	letters.Put("I",Array(7,1))
	letters.Put("J",Array(6,2))
	letters.Put("K",Array(7,2))
	letters.Put("L",Array(8,2))
	letters.Put("M",Array(6,3))
	letters.Put("N",Array(5,3))
	letters.Put("O",Array(8,1))
	letters.Put("P",Array(9,1))
	letters.Put("Q",Array(0,1))
	letters.Put("R",Array(3,1))
	letters.Put("S",Array(1,2))
	letters.Put("T",Array(4,1))
	letters.Put("U",Array(6,1))
	letters.Put("V",Array(3,3))
	letters.Put("W",Array(1,1))
	letters.Put("X",Array(1,3))
	letters.Put("Y",Array(5,1))
	letters.Put("Z",Array(0,3))
	letters.Put(":",Array(9,2))
	letters.Put(" ",Array(7,3))
End Sub
#if java
import javafx.scene.layout.*;
import javafx.scene.canvas.*;
import javafx.scene.control.*;
import javafx.scene.Node;
import javafx.scene.paint.*;
import javafx.scene.image.*;
import javafx.scene.transform.Rotate;
import javafx.geometry.*;
import java.util.*;
import javafx.util.Duration;
import javafx.animation.*;
import javafx.event.*;


private static Rotate[] rotation = new Rotate[20];
private static Rotate[] rotation1 = new Rotate[20];
private static Timeline[] timeline = new Timeline[20];
 
public static GridPane newGridPane(){
	GridPane g = new GridPane();
	g.setHgap(4.0);
	g.setVgap(0.0);
	return g;
}

public static ImageView newImageView(Double w,Double h){
	ImageView iv = new ImageView();
	iv.setFitWidth(w);
	iv.setFitHeight(h);
	return iv;
}

public static Image newImage(String s){
	System.out.println(s);
	return new Image(s);
}

public static void setImage(ImageView iv,Image im,Double left,Double top,Double w,Double h){
	iv.setImage(im);
	Rectangle2D rect = new Rectangle2D(left,top,w,h);
	iv.setViewport(rect);
}

public static void addToGrid(GridPane g,Node n,int x,int y){
	g.add(n, x, y);
}

public static void buildAnimation(GridPane g,int i,Object[] n,Image img,List<float[]>list){
	// force grid to be infront of grid2
	g.toFront();
	// clear transforms on the imageviewa
	for (int nn=0; nn<4; nn++){	
		((ImageView)n[nn]).getTransforms().clear();
	}
	//rotation for top image
	rotation[i] = new Rotate();
    rotation[i].setPivotX(0.0);
	rotation[i].setPivotY(57.5);
    rotation[i].setPivotZ(0.0);
	rotation[i].setAxis(new Point3D(1,0,0));
	// rotation for bottom image
	rotation1[i] = new Rotate();
    rotation1[i].setPivotX(0.0);
	rotation1[i].setPivotY(0.0);
    rotation1[i].setPivotZ(0.0);
	rotation1[i].setAngle(90.0);
	rotation1[i].setAxis(new Point3D(1,0,0));
	// delay in ms between actions NOT frames
	int flipDelay = 100;
	// actual timing variable - incremented by flipDelay on each loop
	int dd = 0;
	// add rotations to the imageviews - only grid 1 as background never moves
	((ImageView)n[0]).getTransforms().add(rotation[i]);
	((ImageView)n[1]).getTransforms().add(rotation1[i]);
	
	boolean first = true;
	timeline[i] = new Timeline();
	for (float[] o:list){
		float left,top,left1,top1,left2,top2,left3,top3;
		left = (float) o[0];
		top = (float) o[1];
		left1 = (float) o[2];
		top1 = (float) o[3];

		left2 = (float) o[4];
		top2 = (float) o[5];
		left3 = (float) o[6];
		top3 = (float) o[7];
		// set the images
		//foreground
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[0]).viewportProperty(),setViewPort(left, top, 75, (float) 57.5))));
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[1]).viewportProperty(),setViewPort(left1, top1, 75, (float) 50.5))));
		if (first){
			//background
			timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[2]).viewportProperty(),setViewPort(left, top, 75, (float) 57.5))));
			timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[3]).viewportProperty(),setViewPort(left1, top1, 75, (float) 50.5))));
			first = false;
		}else{
			//background
			timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[3]).viewportProperty(),setViewPort(left1, top1, 75, (float) 50.5))));
		}
		// set image - top background
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[2]).viewportProperty(),setViewPort(left2, top2, 75, (float) 57.5))));
		//set angles
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(rotation[i].angleProperty(), 0)));
		dd+=flipDelay;
		// start top rotate
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(rotation[i].angleProperty(),90)));
		//change images @90 deg
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[0]).viewportProperty(),setViewPort(left2, top2, 75, (float) 57.5))));
		// change angle for top
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(rotation[i].angleProperty(),0)));
		//change image for bottom
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[1]).viewportProperty(),setViewPort(left3, top3, 75, (float) 50.5))));
		//start bottom rotate
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(rotation1[i].angleProperty(),90)));
		dd+=flipDelay;
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(rotation1[i].angleProperty(),0)));
		//change image for back
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(((ImageView)n[3]).viewportProperty(),setViewPort(left3, top3, 75, (float) 52.5))));
		//change angke for bottom
		timeline[i].getKeyFrames().add(new KeyFrame(Duration.millis(dd), new KeyValue(rotation1[i].angleProperty(),90)));
	}
	// play the timeline animation - this happens for each digit and are separate
	// this one is only for digit [i] (whatever that is when called)
	timeline[i].play();
}

public static Rectangle2D setViewPort(float left,float top,float w,float h){
	return new Rectangle2D(left,top,w,h);
}
#end if

